from abc import abstractmethod
from typing import Generic, TypeVar

from .result import Result


P = TypeVar("P")
class Transformer(Generic[P]):
    @abstractmethod
    def parse(self, stream: str, at_index: int) -> Result[P]:
        raise Exception("Abstract method.")
